// Code generated by protoc-gen-go. DO NOT EDIT.
// source: model.proto

/*
Package models is a generated protocol buffer package.

It is generated from these files:
	model.proto

It has these top-level messages:
	ContactRequestOrResponse
	BoolMessageReply
	Phone
	Empty
	Contact
*/
package models

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"

import (
	context "golang.org/x/net/context"
	grpc "google.golang.org/grpc"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type ContactRequestOrResponse struct {
	Phone   *Phone   `protobuf:"bytes,1,opt,name=phone" json:"phone,omitempty"`
	Contact *Contact `protobuf:"bytes,2,opt,name=contact" json:"contact,omitempty"`
}

func (m *ContactRequestOrResponse) Reset()                    { *m = ContactRequestOrResponse{} }
func (m *ContactRequestOrResponse) String() string            { return proto.CompactTextString(m) }
func (*ContactRequestOrResponse) ProtoMessage()               {}
func (*ContactRequestOrResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func (m *ContactRequestOrResponse) GetPhone() *Phone {
	if m != nil {
		return m.Phone
	}
	return nil
}

func (m *ContactRequestOrResponse) GetContact() *Contact {
	if m != nil {
		return m.Contact
	}
	return nil
}

type BoolMessageReply struct {
	IsOk bool   `protobuf:"varint,1,opt,name=isOk" json:"isOk,omitempty"`
	Msg  string `protobuf:"bytes,2,opt,name=msg" json:"msg,omitempty"`
}

func (m *BoolMessageReply) Reset()                    { *m = BoolMessageReply{} }
func (m *BoolMessageReply) String() string            { return proto.CompactTextString(m) }
func (*BoolMessageReply) ProtoMessage()               {}
func (*BoolMessageReply) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *BoolMessageReply) GetIsOk() bool {
	if m != nil {
		return m.IsOk
	}
	return false
}

func (m *BoolMessageReply) GetMsg() string {
	if m != nil {
		return m.Msg
	}
	return ""
}

type Phone struct {
	Number string `protobuf:"bytes,1,opt,name=number" json:"number,omitempty"`
}

func (m *Phone) Reset()                    { *m = Phone{} }
func (m *Phone) String() string            { return proto.CompactTextString(m) }
func (*Phone) ProtoMessage()               {}
func (*Phone) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *Phone) GetNumber() string {
	if m != nil {
		return m.Number
	}
	return ""
}

type Empty struct {
}

func (m *Empty) Reset()                    { *m = Empty{} }
func (m *Empty) String() string            { return proto.CompactTextString(m) }
func (*Empty) ProtoMessage()               {}
func (*Empty) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{3} }

type Contact struct {
	Name    string           `protobuf:"bytes,1,opt,name=name" json:"name,omitempty"`
	Address *Contact_Address `protobuf:"bytes,2,opt,name=address" json:"address,omitempty"`
}

func (m *Contact) Reset()                    { *m = Contact{} }
func (m *Contact) String() string            { return proto.CompactTextString(m) }
func (*Contact) ProtoMessage()               {}
func (*Contact) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{4} }

func (m *Contact) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Contact) GetAddress() *Contact_Address {
	if m != nil {
		return m.Address
	}
	return nil
}

type Contact_Address struct {
	City      string `protobuf:"bytes,1,opt,name=City" json:"City,omitempty"`
	Street    string `protobuf:"bytes,2,opt,name=Street" json:"Street,omitempty"`
	Building  string `protobuf:"bytes,3,opt,name=Building" json:"Building,omitempty"`
	Apartment string `protobuf:"bytes,4,opt,name=Apartment" json:"Apartment,omitempty"`
}

func (m *Contact_Address) Reset()                    { *m = Contact_Address{} }
func (m *Contact_Address) String() string            { return proto.CompactTextString(m) }
func (*Contact_Address) ProtoMessage()               {}
func (*Contact_Address) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{4, 0} }

func (m *Contact_Address) GetCity() string {
	if m != nil {
		return m.City
	}
	return ""
}

func (m *Contact_Address) GetStreet() string {
	if m != nil {
		return m.Street
	}
	return ""
}

func (m *Contact_Address) GetBuilding() string {
	if m != nil {
		return m.Building
	}
	return ""
}

func (m *Contact_Address) GetApartment() string {
	if m != nil {
		return m.Apartment
	}
	return ""
}

func init() {
	proto.RegisterType((*ContactRequestOrResponse)(nil), "models.ContactRequestOrResponse")
	proto.RegisterType((*BoolMessageReply)(nil), "models.BoolMessageReply")
	proto.RegisterType((*Phone)(nil), "models.Phone")
	proto.RegisterType((*Empty)(nil), "models.Empty")
	proto.RegisterType((*Contact)(nil), "models.Contact")
	proto.RegisterType((*Contact_Address)(nil), "models.Contact.Address")
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// Client API for AddressBook service

type AddressBookClient interface {
	AddContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error)
	FindAll(ctx context.Context, in *Empty, opts ...grpc.CallOption) (AddressBook_FindAllClient, error)
	FindByNumber(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*ContactRequestOrResponse, error)
	EditContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error)
	DeleteContact(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*BoolMessageReply, error)
}

type addressBookClient struct {
	cc *grpc.ClientConn
}

func NewAddressBookClient(cc *grpc.ClientConn) AddressBookClient {
	return &addressBookClient{cc}
}

func (c *addressBookClient) AddContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error) {
	out := new(BoolMessageReply)
	err := grpc.Invoke(ctx, "/models.AddressBook/AddContact", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *addressBookClient) FindAll(ctx context.Context, in *Empty, opts ...grpc.CallOption) (AddressBook_FindAllClient, error) {
	stream, err := grpc.NewClientStream(ctx, &_AddressBook_serviceDesc.Streams[0], c.cc, "/models.AddressBook/FindAll", opts...)
	if err != nil {
		return nil, err
	}
	x := &addressBookFindAllClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type AddressBook_FindAllClient interface {
	Recv() (*ContactRequestOrResponse, error)
	grpc.ClientStream
}

type addressBookFindAllClient struct {
	grpc.ClientStream
}

func (x *addressBookFindAllClient) Recv() (*ContactRequestOrResponse, error) {
	m := new(ContactRequestOrResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *addressBookClient) FindByNumber(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*ContactRequestOrResponse, error) {
	out := new(ContactRequestOrResponse)
	err := grpc.Invoke(ctx, "/models.AddressBook/FindByNumber", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *addressBookClient) EditContact(ctx context.Context, in *ContactRequestOrResponse, opts ...grpc.CallOption) (*BoolMessageReply, error) {
	out := new(BoolMessageReply)
	err := grpc.Invoke(ctx, "/models.AddressBook/EditContact", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *addressBookClient) DeleteContact(ctx context.Context, in *Phone, opts ...grpc.CallOption) (*BoolMessageReply, error) {
	out := new(BoolMessageReply)
	err := grpc.Invoke(ctx, "/models.AddressBook/DeleteContact", in, out, c.cc, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for AddressBook service

type AddressBookServer interface {
	AddContact(context.Context, *ContactRequestOrResponse) (*BoolMessageReply, error)
	FindAll(*Empty, AddressBook_FindAllServer) error
	FindByNumber(context.Context, *Phone) (*ContactRequestOrResponse, error)
	EditContact(context.Context, *ContactRequestOrResponse) (*BoolMessageReply, error)
	DeleteContact(context.Context, *Phone) (*BoolMessageReply, error)
}

func RegisterAddressBookServer(s *grpc.Server, srv AddressBookServer) {
	s.RegisterService(&_AddressBook_serviceDesc, srv)
}

func _AddressBook_AddContact_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ContactRequestOrResponse)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).AddContact(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/models.AddressBook/AddContact",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).AddContact(ctx, req.(*ContactRequestOrResponse))
	}
	return interceptor(ctx, in, info, handler)
}

func _AddressBook_FindAll_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Empty)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(AddressBookServer).FindAll(m, &addressBookFindAllServer{stream})
}

type AddressBook_FindAllServer interface {
	Send(*ContactRequestOrResponse) error
	grpc.ServerStream
}

type addressBookFindAllServer struct {
	grpc.ServerStream
}

func (x *addressBookFindAllServer) Send(m *ContactRequestOrResponse) error {
	return x.ServerStream.SendMsg(m)
}

func _AddressBook_FindByNumber_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Phone)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).FindByNumber(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/models.AddressBook/FindByNumber",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).FindByNumber(ctx, req.(*Phone))
	}
	return interceptor(ctx, in, info, handler)
}

func _AddressBook_EditContact_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ContactRequestOrResponse)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).EditContact(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/models.AddressBook/EditContact",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).EditContact(ctx, req.(*ContactRequestOrResponse))
	}
	return interceptor(ctx, in, info, handler)
}

func _AddressBook_DeleteContact_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Phone)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AddressBookServer).DeleteContact(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/models.AddressBook/DeleteContact",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AddressBookServer).DeleteContact(ctx, req.(*Phone))
	}
	return interceptor(ctx, in, info, handler)
}

var _AddressBook_serviceDesc = grpc.ServiceDesc{
	ServiceName: "models.AddressBook",
	HandlerType: (*AddressBookServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "AddContact",
			Handler:    _AddressBook_AddContact_Handler,
		},
		{
			MethodName: "FindByNumber",
			Handler:    _AddressBook_FindByNumber_Handler,
		},
		{
			MethodName: "EditContact",
			Handler:    _AddressBook_EditContact_Handler,
		},
		{
			MethodName: "DeleteContact",
			Handler:    _AddressBook_DeleteContact_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "FindAll",
			Handler:       _AddressBook_FindAll_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "model.proto",
}

func init() { proto.RegisterFile("model.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 380 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xac, 0x53, 0xcf, 0xee, 0x93, 0x40,
	0x10, 0x2e, 0xfd, 0x47, 0x3b, 0xd8, 0xd8, 0xcc, 0x41, 0x09, 0x31, 0xb1, 0xc1, 0x8b, 0x5e, 0x88,
	0xd6, 0x8b, 0xf1, 0x60, 0x02, 0xb5, 0x1e, 0x34, 0x5a, 0xb3, 0x3e, 0x01, 0xed, 0x4e, 0x2a, 0x16,
	0x76, 0x91, 0xdd, 0x1e, 0x78, 0x3c, 0x1f, 0xc6, 0xf7, 0x30, 0x2c, 0xbb, 0x35, 0x72, 0x50, 0x0f,
	0xbf, 0xdb, 0xcc, 0x7c, 0xdf, 0x7c, 0xf3, 0xed, 0x0c, 0x40, 0x50, 0x49, 0x4e, 0x65, 0x52, 0x37,
	0x52, 0x4b, 0x9c, 0x9b, 0x44, 0xc5, 0xdf, 0x20, 0xdc, 0x49, 0xa1, 0xf3, 0x93, 0x66, 0xf4, 0xfd,
	0x4a, 0x4a, 0x1f, 0x1a, 0x46, 0xaa, 0x96, 0x42, 0x11, 0x3e, 0x81, 0x59, 0xfd, 0x55, 0x0a, 0x0a,
	0xbd, 0x8d, 0xf7, 0x34, 0xd8, 0xae, 0x92, 0xbe, 0x27, 0xf9, 0xdc, 0x15, 0x59, 0x8f, 0xe1, 0x33,
	0xf0, 0x4f, 0xbd, 0x40, 0x38, 0x36, 0xb4, 0xfb, 0x8e, 0xe6, 0x74, 0x1d, 0x1e, 0xbf, 0x82, 0x75,
	0x26, 0x65, 0xf9, 0x91, 0x94, 0xca, 0xcf, 0xc4, 0xa8, 0x2e, 0x5b, 0x44, 0x98, 0x16, 0xea, 0x70,
	0x31, 0x23, 0x16, 0xcc, 0xc4, 0xb8, 0x86, 0x49, 0xa5, 0xce, 0x46, 0x6e, 0xc9, 0xba, 0x30, 0x7e,
	0x0c, 0x33, 0x33, 0x14, 0x1f, 0xc0, 0x5c, 0x5c, 0xab, 0x23, 0x35, 0xa6, 0x61, 0xc9, 0x6c, 0x16,
	0xfb, 0x30, 0xdb, 0x57, 0xb5, 0x6e, 0xe3, 0x1f, 0x1e, 0xf8, 0x76, 0x70, 0xa7, 0x2d, 0xf2, 0x8a,
	0x2c, 0xd5, 0xc4, 0xf8, 0x02, 0xfc, 0x9c, 0xf3, 0x86, 0x94, 0xb2, 0x76, 0x1f, 0x0e, 0xec, 0x26,
	0x69, 0x0f, 0x33, 0xc7, 0x8b, 0x24, 0xf8, 0xb6, 0xd6, 0x29, 0xee, 0x0a, 0xdd, 0x3a, 0xc5, 0x2e,
	0xee, 0x2c, 0x7d, 0xd1, 0x0d, 0x91, 0xb6, 0x86, 0x6d, 0x86, 0x11, 0x2c, 0xb2, 0x6b, 0x51, 0xf2,
	0x42, 0x9c, 0xc3, 0x89, 0x41, 0x6e, 0x39, 0x3e, 0x82, 0x65, 0x5a, 0xe7, 0x8d, 0xae, 0x48, 0xe8,
	0x70, 0x6a, 0xc0, 0xdf, 0x85, 0xed, 0xcf, 0x31, 0x04, 0x76, 0x62, 0x26, 0xe5, 0x05, 0xdf, 0x03,
	0xa4, 0x9c, 0xbb, 0x57, 0x6d, 0x86, 0xfb, 0x1d, 0xde, 0x2d, 0x0a, 0x1d, 0x63, 0xb8, 0xed, 0x78,
	0x84, 0x6f, 0xc0, 0x7f, 0x57, 0x08, 0x9e, 0x96, 0x25, 0xde, 0xee, 0x69, 0x36, 0x17, 0xfd, 0x53,
	0x37, 0x1e, 0x3d, 0xf7, 0x30, 0x85, 0x7b, 0x5d, 0x7f, 0xd6, 0x7e, 0x32, 0x8b, 0xc7, 0x3f, 0x3f,
	0x8a, 0xff, 0x11, 0xc1, 0x0f, 0x10, 0xec, 0x79, 0xa1, 0xef, 0xe6, 0x3d, 0xaf, 0x61, 0xf5, 0x96,
	0x4a, 0xd2, 0xe4, 0xe4, 0x06, 0x86, 0xfe, 0xd2, 0x7b, 0x9c, 0x9b, 0x5f, 0xe1, 0xe5, 0xaf, 0x00,
	0x00, 0x00, 0xff, 0xff, 0x1b, 0x25, 0x84, 0x82, 0x19, 0x03, 0x00, 0x00,
}
